<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                template="./../plantilla-principal.xhtml"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:c="http://xmlns.jcp.org/jsp/jstl/core"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://xmlns.jcp.org/jsf/core"
                xmlns:jsf="http://xmlns.jcp.org/jsf">

    <ui:define name="contenido">
        <h2 class="ui header">Estados de suscripciones</h2>
        <h:form class="ui secondary menu">
        <!--<div class="ui secondary menu">-->
            
            <div class="ui fitted item">
                <h:commandLink id="btn-limpiar" class="ui right labeled green icon button" action="#{cambioEstadoManBean.limpiarFormulario()}">
                    <i class="file icon" />
                    Limpiar
                    <f:ajax execute="@this" render="form-datos:lbl-estado-act form-datos:in-chk-inmediato form-datos:in-observacion" onevent="function(data){ajaxLimpiar(data)}" />
                </h:commandLink>
            </div>
            
        <!--</div>-->
        </h:form>
        <div class="ui grid">
            <div class="ten wide column">
                <h:form id="form-tabla">
                    <table jsf:id="tabla-datos" class="ui selectable celled table">
                        <thead>
                            <tr>
                                <th>Suscripción</th>
                                <th>Cambio</th>
                                <th>F. Solicitud</th>
                                <th>F. Concretado</th>
                                <th class="collapsing"></th>
                                <th class="collapsing"></th>
                            </tr>
                        </thead>
                        <tbody>
                            <ui:repeat value="#{cambioEstadoManBean.lstSolicitudes}" var="sol" varStatus="solStatus">
                                <tr>
                                    <td>
                                        #{sol.suscripcion.idsuscripcion}-#{sol.suscripcion.cliente.razonSocial}(ci: #{sol.suscripcion.cliente.ci}) | #{sol.suscripcion.direccion} 
                                    </td>
                                    <td>
                                        De #{sol.estadoAnterior.nombre} a #{sol.estadoNuevo.nombre}
                                    </td>
                                    <td>
                                        <h:outputText value="#{sol.fechaSolicitud}">
                                            <f:convertDateTime pattern="dd/MM/yyyyy" />
                                        </h:outputText>
                                    </td>
                                    <td>
                                        <h:outputText rendered="#{sol.fechaConcrecion!=null}" value="#{sol.fechaConcrecion}">
                                            <f:convertDateTime pattern="dd/MM/yyyy" />
                                        </h:outputText>
                                        <h:outputText value="(Pendiente)" rendered="#{sol.fechaConcrecion==null}" />
                                    </td>
                                    <td class="center aligned">
                                        <div data-inverted="" data-tooltip="Aprobar solicitud" jsf:rendered="#{!sol.concretado}">
                                            <h:commandLink action="#{cambioEstadoManBean.aprobarSolicitud(sol.idsolicitud)}">
                                                <i class="green checkmark icon" />
                                                <f:ajax execute="@this" render="form-tabla form-datos:tx-formulario form-datos:in-tipo-msg" onevent="function(data){ajaxRegistrarSolicitud(data)}" />
                                            </h:commandLink>
                                        </div>
                                    </td>
                                    <td class="center aligned">
                                        <div data-inverted="" data-tooltip="Descartar solicitud" jsf:rendered="#{!sol.concretado}">
                                            <h:commandLink action="#{cambioEstadoManBean.eliminarSolicitud(sol.idsolicitud)}">
                                                <i class="orange trash icon" />
                                                <f:ajax execute="@this" render="form-tabla form-datos:tx-formulario form-datos:in-tipo-msg" onevent="function(data){ajaxRegistrarSolicitud(data)}" />
                                            </h:commandLink>
                                        </div>
                                    </td>
                                </tr>
                            </ui:repeat>
                        </tbody>
                    </table>
                </h:form>
            </div>
            <div class="six wide column">

                <div class="ui pointing secondary menu">
                    <a id="tab-filtros" class="item active" data-tab="formulario">Formulario</a>
                    <a id="tab-formulario" class="item" data-tab="filtros">Filtros</a>
                </div>
                <div class="ui active tab" data-tab="formulario">
                    <h:form id="form-datos">
                        <div class="ui form">
                            <div class="field">
                                <label>Suscripción</label>
                                <div id="cmb-form-susc" class="ui search selection dropdown">
                                    <input name="in-form-susc" type="hidden" jsf:value="#{cambioEstadoManBean.idSuscripcionCrear}" />
                                    <i class="dropdown icon"></i>
                                    <div class="default text">Suscripción</div>
                                    <div class="menu">
                                    </div>
                                </div>
                            </div>
                            <div class="field">
                                <label>Estado Actual</label>
                                <div jsf:id="lbl-estado-act" class="#{utilConversion.getColorLabelEstado(cambioEstadoManBean.suscSeleccionada.estado.idestado)}">
                                    #{cambioEstadoManBean.suscSeleccionada.estado.nombre}
                                </div>
                            </div>
                            <div class="field">
                                <label>Estado nuevo</label>
                                <div id="cmb-estado-nuevo" class="ui selection dropdown">
                                    <input name="in-estado" type="hidden" jsf:value="#{cambioEstadoManBean.idNuevoEstado}" />
                                    <i class="dropdown icon"></i>
                                    <div class="default text">Estado</div>
                                    <div class="menu">
                                        <ui:repeat value="#{estadoSusManBean.estadosSuscripcion}" var="est" varStatus="estStatus">
                                            <div class="item" data-value="#{est.idestado}">#{est.nombre}</div>
                                        </ui:repeat>
                                    </div>
                                </div>
                            </div>
                            <div class="field">
                                <label>Observación</label>
                                <input jsf:id="in-observacion" type="text" placeholder="Observación" class="ui input" jsf:value="#{cambioEstadoManBean.observacionNuevo}" />
                            </div>
                            <div class="field">
                                <div class="ui checkbox">
                                    <input jsf:id="in-chk-inmediato" name="in-chk-inmediato"  type="checkbox" jsf:value="#{cambioEstadoManBean.efectoInmediato}" />
                                    <label>Efecto inmediato</label>
                                </div>
                            </div>
                            <h:commandLink id="cml-seleccion-susc" style="display: none" action="#{cambioEstadoManBean.seleccionSuscripcion()}">
                                <f:ajax execute="@this form-datos:in-form-susc" render="form-datos:lbl-estado-act" />
                            </h:commandLink>
                            <h:commandLink class="ui blue right labeled icon button" action="#{cambioEstadoManBean.registrarSolicitud()}">
                                <i class="add circle icon" />
                                Registrar
                                <f:ajax execute="@form" render="form-tabla form-datos:tx-formulario form-datos:in-tipo-msg" onevent="function(data){ajaxRegistrarSolicitud(data)}" />
                            </h:commandLink>
                        </div>
                        <div id="msg-formulario" class="ui hidden info message">
                            <i class="close icon" />
                            <div class="header">
                                Info
                            </div>
                            <input jsf:id="in-tipo-msg" type="hidden" value="#{cambioEstadoManBean.tipoMsg}" />
                            <h:outputText id="tx-formulario" value="#{cambioEstadoManBean.msg}"/>
                        </div>
                    </h:form>
                </div>
                <div class="ui tab" data-tab="filtros">
                    <h:form id="form-filtros">
                        <div class="ui form">
                            <div class="field">
                                <div id="chk-filtro-todos" class="ui checkbox">
                                    <input name="in-filtro-todos" type="checkbox" jsf:value="#{cambioEstadoManBean.todasSuscFiltro}" />
                                    <label>Todas las suscripciones</label>
                                </div>
                            </div>
                            <div class="field">
                                <label>Suscripción</label>
                                <div id="cmb-filt-susc" class="ui disabled search selection dropdown">
                                    <input name="in-susc-filtro" type="hidden" />
                                    <i class="dropdown icon"></i>
                                    <div class="default text">Suscripción</div>
                                    <div class="menu">
                                    </div>
                                </div>
                            </div>
                            <div class="field">
                                <div class="ui checkbox" onclick="$('#form-filtros\\:cml-filtrar').click()">
                                    <input name="in-filtro-pendientes"  type="checkbox" jsf:value="#{cambioEstadoManBean.pendientesFiltro}" />
                                    <label>Pendientes</label>
                                </div>
                                <div class="ui checkbox" onclick="$('#form-filtros\\:cml-filtrar').click()">
                                    <input name="in-filtro-concretaros" type="checkbox" jsf:value="#{cambioEstadoManBean.concretadosFiltro}" />
                                    <label>Concretados</label>
                                </div>
                            </div>
                        </div>
                        <h:commandLink id="cml-filtrar" style="display: none" action="#{cambioEstadoManBean.filtrar()}" >
                            <f:ajax execute="@form" render="form-tabla" />
                        </h:commandLink>
                    </h:form>
                </div>

            </div>
        </div>
        <script type="text/javascript">
            function ajaxLimpiar(data){
                var s=data.status;
                switch(s){
                    case 'success':{
                            limpiar();
                            break;
                    }
                }
            }
            function limpiar(){
                $('#cmb-form-susc').dropdown('clear');
                $('#cmb-estado-nuevo').dropdown('clear');
            }
            $('.message .close').on('click', function () {
                $(this).closest('.message').transition('fade');
            });
            function ajaxProcesarFiltros(data) {
                var s = data.status;
                switch (s) {
                    case 'success':
                    {
                        break;
                    }
                }
            }
            $(document).ready(function () {

                $('#tab-filtros').tab();
                $('#tab-formulario').tab();
                $('#cmb-filt-susc').dropdown({
                    apiSettings: {
                        url: '//' + location.host + restRootPath + '/buscsuscdropdown?q={query}'
                    }
                });
                $('#cmb-form-susc').dropdown({
                    apiSettings: {
                        url: '//' + location.host + restRootPath + '/buscsuscdropdown?q={query}'
                    },
                    onChange: function () {
                        console.log('cambio suscripcion');
                        $('#form-datos\\:cml-seleccion-susc').click();
                    }
                });
            });
            $("#chk-filtro-todos").click(function () {
//                console.log('click check');
                if ($("#form-filtros\\:in-filtro-todos").prop("checked")) {
                    console.log('checked');
                    $('#cmb-filt-susc').addClass('disabled');
                } else {
                    console.log('unchecked');
                    $('#cmb-filt-susc').removeClass('disabled');
                }

            });
            function mostrarMsg(){
                var tipof=$('#in-tipo-msg').val();
                if(tipof===1){
                    console.log("tipo msg info");
                    $('#msg-formulario').removeClass('negative');
                    $('#msg-formulario').removeClass('warning');
                    $('#msg-formulario').addClass('info');
                }else if(tipof===2){
                    console.log("tipo msg warning");
                    $('#msg-formulario').removeClass('negative');
                    $('#msg-formulario').addClass('warning');
                    $('#msg-formulario').removeClass('info');
                }else if(tipof===3){
                    console.log("tipo msg error");
                    $('#msg-formulario').addClass('negative');
                    $('#msg-formulario').removeClass('warning');
                    $('#msg-formulario').removeClass('info');
                }
                if($('#msg-formulario').css('display')==='none'){
                    $('#msg-formulario').transition('fade');
                }
            }
            function ajaxRegistrarSolicitud(data){
                var s=data.status;
                switch(s){
                    case 'success':{
                            mostrarMsg();
                            break;
                    }
                }
            }
        </script>
    </ui:define>

</ui:composition>
